﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using AForge.Video;
using AForge.Video.DirectShow;
using AForge.Video.FFMPEG;
using AForge.Video.VFW;

namespace InterfaceWebCam
{

    public partial class Form1 : Form
    {
        private FilterInfoCollection VideoCaptureDevices;
        public int time;
        public bool snapshotTrigger = false;

        private VideoCaptureDevice FinalVideo = null;
        private VideoCaptureDeviceForm captureDevice;
        private Bitmap video;
        //private AVIWriter AVIwriter = new AVIWriter();
        private VideoFileWriter FileWriter = new VideoFileWriter();
        private SaveFileDialog saveAvi;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            if (captureDevice.ShowDialog(this) == DialogResult.OK)
            {
                FinalVideo = captureDevice.VideoDevice;
                FinalVideo.NewFrame += new NewFrameEventHandler(FinalVideo_NewFrame);
                FinalVideo.Start();

                btnStartRecording.Enabled = true;
                btnStopRecording.Enabled = false;
                btnConnect.Enabled = false;

                pictureBox1.Width = captureDevice.VideoDevice.VideoResolution.FrameSize.Width;
                pictureBox1.Height = captureDevice.VideoDevice.VideoResolution.FrameSize.Height;

                this.Size = new System.Drawing.Size(captureDevice.VideoDevice.VideoResolution.FrameSize.Width, captureDevice.VideoDevice.VideoResolution.FrameSize.Height);
                this.MaximumSize = new System.Drawing.Size(captureDevice.VideoDevice.VideoResolution.FrameSize.Width, captureDevice.VideoDevice.VideoResolution.FrameSize.Height);
                this.MinimumSize = new System.Drawing.Size(captureDevice.VideoDevice.VideoResolution.FrameSize.Width, captureDevice.VideoDevice.VideoResolution.FrameSize.Height);

            }
        }

        private void btnRecording_Click(object sender, EventArgs e)
        {
            saveAvi = new SaveFileDialog();
            saveAvi.Filter = "Avi Files (*.avi)|*.avi";
            if (saveAvi.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                int h = captureDevice.VideoDevice.VideoResolution.FrameSize.Height;
                int w = captureDevice.VideoDevice.VideoResolution.FrameSize.Width;
                FileWriter.Open(saveAvi.FileName, w, h, 25, VideoCodec.Default, 5000000);
                FileWriter.WriteVideoFrame(video);

                //AVIwriter.Open(saveAvi.FileName, w, h);
                btnStartRecording.Enabled = false;
                btnStopRecording.Enabled = true;
                recordLabel.Visible = true;
                //pictureBox1.Visible = true;
                //pictureBox2.Visible = false;
            }
        }

        private void btnStopRecording_Click(object sender, EventArgs e)
        {
            if (btnStopRecording.Enabled == true)
            {
                btnStopRecording.Enabled = false;
                recordLabel.Visible = false;
                if (FinalVideo == null)
                { return; }
                if (FinalVideo.IsRunning)
                {
                    //this.FinalVideo.Stop();
                    FileWriter.Close();
                    //this.AVIwriter.Close();
                    //pictureBox1.Image = null;
                    //pictureBox2.Image = null;
                    btnStartRecording.Enabled = true;
                }
            }
            else
            {
                this.FinalVideo.Stop();
                FileWriter.Close();
                //this.AVIwriter.Close();
                pictureBox1.Image = null;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            VideoCaptureDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
            captureDevice = new VideoCaptureDeviceForm();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Enabled = false;
            timer2.Enabled = false;

            if (FinalVideo == null)
            { return; }
            if (FinalVideo.IsRunning)
            {
                FileWriter.Close();
                MessageBox.Show("Exiting program cleanly."); //See comment on next line! This is important!!
                //Thread.Sleep(5000); //This doesn't work. But if the MessageBox above is removed, the program returns an error when it closes and a process remains running! 
                this.FinalVideo.Stop();
            }
        }

        void FinalVideo_NewFrame(object sender, NewFrameEventArgs eventArgs)
        {
            this.Invoke((MethodInvoker)delegate
            {
                try
                {
                    if (video != null)
                    {
                        video.Dispose();
                    }
                    video = new Bitmap(eventArgs.Frame);
                }
                catch { }

                this.Invoke((MethodInvoker)delegate
                {
                    if (btnStopRecording.Enabled == true)
                    {
                        video = (Bitmap)eventArgs.Frame.Clone();
                        pictureBox1.Image = (Bitmap)eventArgs.Frame.Clone();
                        //AVIwriter.Quality = 0;
                        FileWriter.WriteVideoFrame(video);
                        //AVIwriter.AddFrame(video);
                    }
                    else
                    {
                        video = (Bitmap)eventArgs.Frame.Clone();
                        pictureBox1.Image = (Bitmap)eventArgs.Frame.Clone();
                    }
                });
                GC.Collect();
            });
        }

    }
}




/*
        void FinalVideo_NewFrame(object sender, NewFrameEventArgs eventArgs)
        {
            if (butStop.Enabled == true)
            {
                video = (Bitmap)eventArgs.Frame.Clone();
                pictureBox1.Image = (Bitmap)eventArgs.Frame.Clone();
                //if (snapshotTrigger == false) pictureBox2.Image = (Bitmap)eventArgs.Frame.Clone();
                //AVIwriter.Quality = 0;
                FileWriter.WriteVideoFrame(video);
                //AVIwriter.AddFrame(video);
            }
            else
            {
                video = (Bitmap)eventArgs.Frame.Clone();
                pictureBox1.Image = (Bitmap)eventArgs.Frame.Clone();
                if (snapshotTrigger == true)
                {
                    pictureBox2.Image = null;
                    pictureBox2.Image = (Bitmap)eventArgs.Frame.Clone();
                }
            }
        }
*/ 
